/**
 * Ce fichier peut etre cree en utilisant l'option -GI de tao_idl, le fichier cree
 * aura le nom : ConvertisseurI.cpp
 */
#include <iostream>
#include "EuroImpl.h"

using namespace std;

char* EuroImpl::devise()
{
	/**
	 * Toujours faire une copie de ce que l'on renvoie car l'ORB libere l'objet une fois qu'il
	 * est renvoye (ici m_devise.c_str() qui est justement de type const char* donc non modifiable).
	 * Or on ne veut pas que m_devise soit modifie, d'ou la (deep) copy de l'objet renvoye.
	 */
	return CORBA::string_dup(m_devise.c_str());
}

CORBA::Double EuroImpl::taux()
{
	return m_taux;
}

void EuroImpl::devise(const char* _devise)
{
	// Une deep copie (obligatoire) est faite grace a l'operateur '=' de la classe string 
	m_devise = _devise;
}

void EuroImpl::taux(CORBA::Double _taux)
{
	m_taux = _taux;
}

CORBA::Double EuroImpl::toDevise(CORBA::Double euro)
{
	return euro * m_taux;
}

CORBA::Double EuroImpl::toEuro(CORBA::Double devise)
{
	return devise / m_taux;
}
